#include "susi_watchdog.h"
#include "wdtmodver.h"

/*+++ John Add, 20100603*/
#define IOCTL_SUSI_LINUX_DRIVER_VERSION _IOR( 'W', 0, unsigned long )

static unsigned long version[4] = {
		WDTMOD_MAJOR,
		WDTMOD_MINOR,
		WDTMOD_BUILD,
		WDTMOD_REVISION
};
/*--- John Add, 20100603*/

ssize_t susi_wdt_read( struct file *filp, char __user *buf, size_t count, 
			loff_t *f_pos)
{
	printk(KERN_INFO "Watchdog open line num %d\n", __LINE__);
	return 0;
}

/*+++ John Add, 20100603*/
int susi_wdt_ioctl( struct inode *inode, 
								  struct file *filp, 
								  unsigned int cmd,
								  unsigned long arg )
{
	void __user *argp = (void __user *)arg;
	
	switch(cmd)
	{
	case IOCTL_SUSI_LINUX_DRIVER_VERSION:
		if (copy_to_user(argp, version, 4 * sizeof(unsigned long)))
		{
			printk(KERN_ERR "Error: Get driver version failed.\n" );
			return -EFAULT;
		}		
		break;
		
	default:
		printk(KERN_ERR "Error: Not supported IOControl Code.\n" );
		return -ENOTTY;
	}
	
	return 0;
}
/*--- John Add, 20100603*/


