#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Susi.h"
#include "rel_debug.h"
#include "rel_errlib.h"
#include "rel_errdrv.h"

HSUSI hSusi;

int ECInit()
{
	if (!SusiDllInitialize())
	{
		printf("SusiDllInitialize() failed.\r\n");
		return -1;
	}
	else
	{
		printf("SusiDllInitialize() OK.\r\n");
	}
	
	if( !SusiDllInstall(1) )
	{
		SusiDllUninitialize();
		printf("SusiDllInstall(1) failed.\r\n");
		return -1;
	}
	else
	{
		printf("SusiDllInstall(1) OK.\r\n");
	}
	
	if (!SusiBoardOpen(0,0,0, &hSusi))
	{
		SusiDllInstall(0);
		SusiDllUninitialize();
		printf("SusiBoardOpen() failed.\r\n");
		return -1;
	}
	else
	{
		printf("SusiBoardOpen() OK.\r\n");
	}

	return 0;
}

void ECRelease()
{
	SusiBoardClose(hSusi);
	
	SusiDllInstall(0);
	
	SusiDllUninitialize();
}

int main( int argc, char *argv[] )
{	
//	unsigned long ulBoardCount;
//	SUSITCHAR sBoardName[SUSI_BOARD_MAX_SIZE_ID_STRING];
	unsigned long ulBootCounter;
	unsigned long ulRunningTimeMeter;
	SUSIBOARDINFO BoardInfo = {0};
	SUSITCHAR bufRet[50];
	SUSITCHAR bufTmp[50];
//	SUSITCHAR bufBoardVer[3];



	printf("***********************Board test enter.***********************\r\n");
	
	if ( 0 != ECInit() )
	{
		printf("EC Init failed.\r\n");
		return -1;
	}
	else
	{
		printf("EC Init OK.\r\n");
	}	
	
	if(!SusiBoardGetBootCounter(hSusi,&ulBootCounter))
	{
		printf("SusiBoardGetBootCounter() failed.\r\n");
		return -1;
	}
	else
	{
		printf("BootCounter: %ld\r\n",ulBootCounter);
	}

	if(!SusiBoardGetRunningTimeMeter(hSusi,&ulRunningTimeMeter))
	{
		printf("SusiBoardGetRunningTimeMeter() failed.\r\n");
		return -1;
	}
	else
	{
		printf("RunningTimeMeter: %ld\r\n",ulRunningTimeMeter);
	}	
	
	if(!SusiBoardGetInfo(hSusi,&BoardInfo))
	{
		printf("SusiBoardGetInfo() failed.\r\n");
		return -1;
	}
	else
	{		
#if WINCE_VER
		_itow( (BoardInfo.wBiosRevision >> 8) & 0xFF, bufTmp, 16 );
		wcscpy(bufRet, bufTmp);
		wcscat(bufRet, L".");
		_itow( BoardInfo.wBiosRevision & 0xFF, bufTmp, 16 );
		wcscat(bufRet, bufTmp);
		wprintf(L"BIOS Version: %s\r\n",bufRet);	
		
		_itow( (BoardInfo.wFirmwareRevision >> 8) & 0xFF, bufTmp, 16 );
		wcscpy(bufRet, bufTmp);
		wcscat(bufRet, L".");
		_itow( BoardInfo.wFirmwareRevision & 0xFF, bufTmp, 16 );
		wcscat(bufRet, bufTmp);
		wprintf(L"Firmware Version: %s\r\n",bufRet);			
#else	
		sprintf(bufTmp,"%X",(BoardInfo.wBiosRevision >> 8) & 0xFF);
		strcpy(bufRet, bufTmp);
		strcat(bufRet, ".");
		sprintf(bufTmp,"%X",BoardInfo.wBiosRevision & 0xFF);
		strcat(bufRet, bufTmp);
		printf("BIOS Version: %s\r\n",bufRet);

		sprintf(bufTmp,"%X",(BoardInfo.wFirmwareRevision >> 8) & 0xFF);
		strcpy(bufRet, bufTmp);
		strcat(bufRet, ".");
		sprintf(bufTmp,"%X",BoardInfo.wFirmwareRevision & 0xFF);
		strcat(bufRet, bufTmp);
		printf("Firmware Version: %s\r\n",bufRet);
#endif

	}

	ECRelease();

	printf("***********************Board test exit.***********************\r\n");

	return 0;
}

