#include <stdio.h>
#include <stdlib.h>
#include "Susi.h"
#include "rel_debug.h"
#include "rel_errlib.h"
#include "rel_errdrv.h"


int main( int argc, char *argv[] )
{
#if WINCE_VER
	ULONG64 Version;
	//ULONG64 CoreVersion;
	ULONG64 DrvVersion;
#else
	unsigned long long Version;
	//unsigned long long CoreVersion;
	unsigned long long DrvVersion;
#endif

	printf("***********************Dll test enter.***********************\r\n");

	Version = SusiDllGetVersion();
	printf("Library Version: %d", (unsigned short) (Version >> 48));
	printf(".%d", (unsigned short)(Version >> 32) & 0xFFFF);
	printf(".%d", (unsigned short)(Version >> 16) & 0xFFFF);
	printf(".%d\r\n", (unsigned short)(Version & 0xFFFF));

	/*+++ -------------------Init ---------------------------------------*/
	if (!SusiDllInitialize())
	{
		printf("SusiDllInitialize() failed.\r\n");
		return -1;
	}
	else
	{
		printf("SusiDllInitialize() OK.\r\n");
	}

	/*--- -------------------Init ---------------------------------------*/

	if( ! SusiDllIsAvailable() )
	{
		printf("SusiCore is not available.\r\n");
	}
	else
	{
		printf("SusiCore is available.\r\n");
	}		

	if( !SusiDllInstall(1) )
	{
		SusiDllUninitialize();
		printf("SusiDllInstall(1) failed.\r\n");
		return -1;
	}
	else
	{
		printf("SusiDllInstall(1) OK.\r\n");
	}

	DrvVersion = SusiDllGetDrvVersion();
	if(!DrvVersion)
	{
		printf("SusiDllGetDrvVersion() failed.\r\n");
		return -1;
	}
	else
	{
		printf("Driver Version: %d", (unsigned short)(DrvVersion >> 48));
		printf(".%d", (unsigned short)(DrvVersion >> 32) & 0xFFFF);
		printf(".%d", (unsigned short)(DrvVersion >> 16) & 0xFFFF);
		printf(".%d\r\n", (unsigned short)(DrvVersion & 0xFFFF));
	}	
	
	/*+++ -------------------Un-Init---------------------------------------*/	

	SusiDllInstall(0);
	
	SusiDllUninitialize();
	/*--- -------------------Un-Init---------------------------------------*/

	printf("***********************Dll test exit.***********************\r\n");

	return 0;
}
